package lifegame;

/**
 *
 * @author Bright
 * Version 2
 * Update date: March 18, 2017
 */

import java.io.*;
import java.util.Scanner;
 
class LifeGame {
	static int MAXROW=10, MAXCOL=25;
	static int DEAD=0, ALIVE=1;
	static int[][] map = new int[MAXROW][MAXCOL];
	static int[][] newmap= new int[MAXROW][MAXCOL];
	static int Generation=0;
	static Scanner keyboard = new Scanner(System.in);

	LifeGame() {
            Generation = 0;
	}
   
	public static void init()
	{
                int row = 0, col = 0;

		// 起始map狀態,一開始cells皆會DEAD
		for (row = 0 ; row < MAXROW ; row++)
			for (col = 0 ; col < MAXCOL ; col++)
				map[row][col] = DEAD;

		System.out.print("Game of life Program \n");
		System.out.print("Enter (x,y) where (x,y) is a living cell\n");
		System.out.print(" 0 <= x <= " + (MAXROW-1) + " , 0 <= y <= " + (MAXCOL-1) 
                                 + "\n");
		System.out.print("Terminate with (x,y) = ( -1,-1)\n");

		// 輸入活細胞之位置,以(-1,-1)結束輸入	  
		do {         
			System.out.print("x-->");
			System.out.flush();
         	row = keyboard.nextInt();
 
			System.out.print("y-->");
 			col = keyboard.nextInt();
 			if (0 <= row && row < MAXROW && 0 <= col && col < MAXCOL)
				map[row][col] = ALIVE;
			else
				System.out.print("(x,y) exceeds map ranage!\n");
		}  while (row != -1 || col != -1);
	}

	public static int Neighbors(int row,int col)
	{
		int count=0, c=0, r=0;

		// 計算每一個cell的鄰居個數
		// 因為cell本身亦被當做鄰居計算
		// 故最後還要調整

		for (r = row -1 ; r <= row +1; r++)
			for (c = col -1 ;  c <= col + 1 ; c++) {
				if (r < 0 || r >= MAXROW || c < 0 || c >= MAXCOL)
					continue;
				if (map[r][c] == ALIVE)
				      count++;
			}
		// 調整鄰居個數
		if (map[row][col] == ALIVE)
			count-- ;
		return count ;
	}

	// 顯示目前細胞狀態
	public static void output_map()
	{
		int row=0, col=0;
		String space = " ";

		System.out.print(space + "Game of life cell status\n") ;
		System.out.print(space + "------Generation " + (++Generation) +   
                               "-------\n");
		for ( row = 0 ; row < MAXROW ; row++ ) {
			System.out.print("\n");
			System.out.print(space);
			for ( col = 0 ; col < MAXCOL ; col++ )
				if ( map[row][col] == ALIVE )
					System.out.print("@");
				else
					System.out.print("-");
		}
	}

	public static void access()
	{
		int row=0, col=0;
		String ans="";

		do {
			// 計算每一個(row,col)之cell 的鄰居個數
			// 依此個數決定其下一代是生是死。
			// 將下一代的map暫存在newmap以防overwrite map。
			for (row = 0 ; row < MAXROW ; row++)
				for (col = 0 ; col < MAXCOL ; col++)
					switch(Neighbors(row, col)) {
						case 0 :
						case 1 :
						case 4 :
						case 5 :
						case 6 :
						case 7 :
						case 8 :
							newmap[row][col] = DEAD;
							break;
						case 2 :
							newmap[row][col] = map[row][col];
							break;
						case 3 :
							newmap[row][col] = ALIVE;
							break;
					}
			Copymap();  // 將newmap copy to map
			do {
				System.out.print("\nContinue next Generation ?(y/n): ");
				ans = keyboard.next();
							
				if (ans.equals("y") || ans.equals("n"))
					break;
			} while (true);
			if (ans.equals("y"))
				output_map();
		}  while (ans.equals("y"));
	}
   
	// 將newmap copy 至map 中
	public static void Copymap()
	{
		int row=0, col=0;

		for (row = 0 ; row < MAXROW ; row++)
			for (col = 0 ; col < MAXCOL ; col++)
				map[row][col] = newmap[row][col];
	} 

	public static void main (String args[]) //主函數		
	{ 
		LifeGame obj = new LifeGame();

		obj.init();   // 起始map
		obj.output_map();
		obj.access();
	}
} 