package oddmagic;

/**
 *
 * @author Bright
 * Version 2
 * Update date: March 18, 2017
 */

import java.io.*;
import java.util.Scanner;

public class OddMagic
{
	static int MAX=15;
	static int[][] Square = new int[MAX][MAX];  // 定義整數矩陣
	static int N=0;  // 矩陣行列大小變數
	static Scanner keyboard = new Scanner(System.in);

	public static void init()
	{
 		String st = "";

		// 讀取魔術矩陣的大小N,N 為奇數且0 <= N <= 15
		do {
			System.out.print("\nEnter odd matrix size : ");
 			N = keyboard.nextInt();
 			if ( N % 2 == 0 || N <= 0 || N > 15)
			     System.out.print("Should be > 0 and < 15 odd number") ;
			else
			     break ;
		} while (1 == 1);
	}
   
	public static void Magic()
	{
		int i=0, j=0, p=0, q=0, key=0 ;

		// 初始化矩陣內容,矩陣全部清0
		for (i = 0 ; i < N ; i++)
			for (j = 0 ; j < N ; j++)
				Square[i][j] = 0 ;
		Square[0][(N-1)/2] = 1 ; // 將1放至最上列中間位置
		key = 2 ;
		i = 0 ; j = (N-1)/2 ;    // i,j記錄目前所在位置
		while ( key <= N*N ) {
			p = (i-1) % N ;  // p, q為下一步位置, i, j各減1表往西北角移動
			q = (j-1) % N ;
			// p < 0 (超出方陣上方) 則將p 移至N-1(最下列)
			if (p < 0)
				p = N - 1 ;
			// q < 0 (超出方陣左方) 則將q 移至N-1(最右行)
			if (q < 0)
				q = N - 1 ;
			if (Square[p][q] != 0)  // 判斷下一步是否已有數字
				i = (i + 1) % N ;  // 已有數字，則 i 往下填在原值下方，j不變
			else {
				i = p ;		 // 將下一步位置指定給目前位置
				j = q ;
			}
			Square[i][j] = key ;
			key++;
		}
	}

	public static void output()
	{
		int i = 0, j = 0;

		// 顯示魔術矩陣結果
		System.out.print("\nThe " + N + "*" + N + " Magic Matrix\n") ;
		System.out.print("-------------------------\n") ;
		for (i = 0 ; i < N ; i++) {
		     for (j = 0 ; j < N ; j++)
		          System.out.printf("%4d ", Square[i][j]) ;       
		     System.out.print("\n") ;
		}
	}

	public static void main (String args[])  // 主函數		 
	{
		OddMagic obj = new OddMagic();
		int i=0, j=0;

		obj.init() ;
		obj.Magic() ; // 將square 變為N x N 的魔術矩陣
		obj.output() ;
	}
}