package polyadd;

/**
 *
 * @author Bright
 * Version 2
 * Update date: March 18, 2017
 */

public class PolyAdd 
{
	static int DUMMY = -1;
	
 	public void Padd(int a[] , int b[], int c[])
	{
		int p = 0, q = 0, r = 0, m = 0, n = 0 ;
		char result='\0' ;

		m = a[1] ; n = b[1] ;
		p = q = r = 2 ;

		while ( (p <= 2*m) && (q <= 2*n) ) {
			// 比較a與b的指數
			result = compare ( a[p], b[q] ) ;

			switch (result) {
				case '=':
					c[r+1] = a[p+1] + b[q+1] ; // 係數相加
					if ( c[r+1] != 0 ) {
						c[r] = a[p] ;    // 指數assign給c
						r += 2 ;
					}
					p += 2 ; q += 2 ;  // 移至下一個指數位置
					break ;
				case '>':
					c[r+1] = a[p+1] ;
					c[r] = a[p] ;
					p += 2 ; r += 2 ;
					break ;
				case '<':
					c[r+1] = b[q+1] ;
					c[r] = b[q] ;
					q += 2 ; r += 2 ;
					break ;
			}
		}
		while (p <= 2*m) { // 將多項式a的餘項全部移至c    
			c[r+1] = a[p+1] ;
			c[r] = a[p] ;
			p += 2 ; r += 2 ;
		}
		while (q <= 2*n) { // 將多項式b的餘項全部移至c    
			c[r+1] = b[q+1] ;
			c[r] = b[q] ;
			q += 2 ; r += 2 ;
		}
		c[1] = r/2 - 1 ;    // 計算c總共有多少非零項
	}

	public char compare(int x, int y)
	{
		if (x == y)
			return '=' ;
		else if (x > y)
			return '>' ;
		else
			return '<' ;
	}

	public void output_P(int p[],int n)
	{
		int i=0 ;

		System.out.print("(") ;
		for ( i = 1 ; i <= n ; i++ )  
			System.out.print(p[i] + " ") ;
		System.out.print(")") ;
	}

	public static void main (String args[])  // 主函數		 
	{
		// 多項式的表示方式利用只儲存非零項法
		// 分別儲存每一個非零項的指數及個數，
		// 陣列第一元素放多項式非零項個數。
		// ex: 下列A多項式有3個非零項，其多項式為 :
		//     5x四次方 + 3x二次方 + 2

		PolyAdd obj = new PolyAdd() ;
		int[] A = new int[8];
		int[] B = new int[8];
		int[] C = new int[13];  // C的大小應為2*(A[1]+B[1]) +1
		int index=0;
  
		A[0]=DUMMY; A[1]=3; A[2]=4; A[3]=5; A[4]=2; A[5]=3;
		A[6]=0; A[7]=2;   
                
		B[0]=DUMMY; B[1]=3; B[2]=3; B[3]=6; B[4]=2; B[5]=2;
		B[6]=0; B[7]=1;
		for (index=1;index<13;index++)
			C[index]=0;

		obj.Padd( A, B, C ) ;  // 將A加B放至C

		// 顯示各多項式結果     
		System.out.print("\nA = ") ;
		obj.output_P(A, A[1]*2 +1) ;  // A[1]*2 + 1為陣列A的大小
		System.out.print("\nB = ") ;
		obj.output_P(B, B[1]*2 +1) ;
		System.out.print("\nC = ") ;
		obj.output_P(C, C[1]*2 +1) ;
	}
}
