package doublelist;

/**
 *
 * @author Bright
 * Version 2
 * update date: Feb-28 2017
 */
              
import java.io.*;
import java.util.Scanner;
import java.util.InputMismatchException;

// 定義一個節點，其資料包含左、右子鏈結，姓名及分數
class Student { 
	String name = "";   // 姓名
	int score=0;      // 分數   
	Student llink;    // 節點的左鏈結 
	Student rlink;    // 節點的右鏈結 
}

public class DoubleList {

	Student prev, ptr, head, current, modifyNode;
	static Scanner keyboard = new Scanner(System.in);

	//初始化串列，建立一空節點為HEAD，將左右鏈結皆指向本身 
	DoubleList() 
	{ 
		ptr = new Student();		   
		ptr.name = "0";
		ptr.llink = ptr;
		ptr.rlink = ptr;		   
		head = ptr;
	}
	
	//加入函數，依分數的高低排序
 	public void insert_f() 
 	{   
 		ptr = new Student();		            
		System.out.printf("\n  請輸入學生的英文姓名  : ");
 		ptr.name = keyboard.next();       			
		System.out.printf("  請輸入 Java 成績 : ");
  		ptr.score = keyboard.nextInt();
        
		System.out.println();
		prev = head;
		current = head.rlink;
		while((current != head) && (current.score >= ptr.score)) {
			prev = current;
			current = current.rlink;
		}
		ptr.rlink = current;
		ptr.llink = prev;
		prev.rlink = ptr;
		current.llink = ptr;
		System.out.printf("  %s 已成功的加入\n", ptr.name);
	}
	
	// 刪除函數
	public void delete_f() 
	{ 
		String del_name="";
		int count = 0;
		current = null;
		if(head.rlink == head)    // 無資料顯示錯誤 
			System.out.printf("\n 串列是空的 !!\n\n");
 		else {
			System.out.printf("\n 欲刪除學生的英文姓名: ");
			del_name = keyboard.next(); 
			prev = head;    			
			current = head.rlink;
			while((current!= head) && (!del_name.equals(current.name))) {
				prev = current;
				current = current.rlink;
			} 
 
			if(head != current) { 
				prev.rlink = current.rlink;
				current.rlink.llink = prev;
				current = null;
				System.out.printf("%s 已被刪除了!!\n\n", del_name);
			}
			else			 
				System.out.printf("　串列無　%s　的資料!!\n\n", del_name);
		}
	}
	
    public void modify_f()
    {
        String modify_name;
        int modify_score;
        System.out.printf("欲修改資料的姓名: ");
        modify_name = keyboard.next();
    
        prev = head;
        current = head.rlink;
        while((current != head) && !(current.name).equals(modify_name)) {
            prev = current;
            current = current.rlink;
        }
    
        if (current != head) {
            System.out.printf("**************************\n");
            System.out.printf("原來的分數: %d\n",current.score);
            System.out.printf("**************************\n");
            System.out.printf("新的分數為: ");
            modify_score = keyboard.nextInt();
            current.score = modify_score;
            System.out.printf("已被修改\n");
        }
        else {
            System.out.printf("無此筆資料\n");
            return;
        }
    
        // 1. 指定 current 節點資料給 newNode
        modifyNode = new Student();
        modifyNode.name = current.name;
        modifyNode.score = current.score;
    
        // 2. 刪除 current 節點
        prev.rlink = current.rlink;
        current.rlink.llink = prev;
        // delete current;
        current = null;
    
        // 3. 再重新排序
        prev = head;
        current = head.rlink;
        while ((current != null) && (current.score > modifyNode.score)) {
            prev = current;
            current = current.rlink;
        }
        modifyNode.rlink = current;
        modifyNode.llink = prev;
        prev.rlink = modifyNode;
        current.llink = modifyNode;
    
    }
	// 輸出函數
    public void display_f() 
	{ 
		int count = 0;

		if(head.rlink == head) // 無資料顯示錯誤
			System.out.printf("\n 串列是空的 !!\n");  
		else {
		        System.out.printf("\n%-10s %-10s\n", "學生姓名","Java分數");
			System.out.printf("---------------------------\n");
			current = head.rlink;
			while(current != head) {
				System.out.printf("%-15s %-3d\n", current.name,
				        current.score);
				count++;
				current = current.rlink;
 			}
			System.out.println("---------------------------");
			System.out.println("串列有 " + count + " 筆資料 !!\n");
		}
	}
	
   // 主函數
	public static void main (String args[]) 
	{  
 		int option=0; 
		DoubleList DBLink = new DoubleList();
 
		do {
			System.out.println();			 
			System.out.println("***  雙向鏈結串列 ***");     
 			System.out.println("       <1> 加入     ");
			System.out.println("       <2> 刪除     ");
			System.out.println("       <3> 修改     ");
			System.out.println("       <4> 顯示     ");
			System.out.println("       <5> 結束     ");
			System.out.println("*********************");
			System.out.print("       請選擇 : ");
						 
			try {
				option = keyboard.nextInt();
			} catch(InputMismatchException e) {
				keyboard.nextLine();
				System.out.printf("不正確的數字\n");
				System.out.printf("請重新輸入\n\n");
			}
			
			switch(option) {			   
				case 1 :
					DBLink.insert_f();  //新增函數
					break;
				case 2 :
					DBLink.delete_f();  //刪除函數
					break;
                                case 3:       				
					DBLink.modify_f();  //刪除函數
					break;
				case 4 :
					DBLink.display_f();  //輸出函數
					break;
 				case 5 :
					System.exit(0);	
			}
		} while (true);
	}
} 
