package dfstest;

/**
 *
 * @author Bright
 * Version 3
 * Update date: March 23, 2917
 */

import java.io.*;
import java.util.Scanner;

class Node
{
    int vertex;
	 Node link;
}

class DFsTest
{
	final static int MAX_V=100;   /*最大節點數*/
	Node node = new Node();
	Node lastnode = new Node();
	static Node[] adjlist = new Node[MAX_V+1];        // 宣告相鄰串列
	static boolean[] visited = new boolean[MAX_V+1];  // 記錄頂點是否已拜訪
	static int total_vertex=0;
 
	public void build_adjlist()
	{   
		int vi=0, vj=0, weight=0;
		Scanner inputStream = null;

		try {
			inputStream = new Scanner(new FileInputStream("dfs.dat"));
		} catch(FileNotFoundException e) {
			System.err.println("File dfs.dat not found!");
			System.exit(1);
		}
		
		// 讀取節點總數
		total_vertex = inputStream.nextInt();
        System.out.printf("total_vertex = %d\n", total_vertex);

		for ( vi = 1; vi <= total_vertex; vi++) {
			// 設定陣列及各串列起始值
			visited[vi] = false;
			adjlist[vi] = new Node();
			adjlist[vi].vertex = vi ;
			adjlist[vi].link = null;
		}
		
		// 讀取節點資料
		for ( vi = 1; vi <= total_vertex; vi++ )
			for ( vj = 1; vj <= total_vertex; vj++ ) {
				// 資料檔以相鄰矩陣格式儲存,以1代表相鄰
				// 0 代表不相鄰，將相鄰頂點鏈結在各串列後
 
				weight = inputStream.nextInt();
 
				if ( weight != 0 ) {
					node = new Node();
					node.vertex = vj;
					node.link = null;
					lastnode = searchlast(adjlist[vi]);
					lastnode.link = node;
				}
			} 
			inputStream.close(); 
	}

	// 顯示各相鄰串列之資料
	public void show_adjlist()
	{
		int index=0;
		Node ptr = new Node();

		System.out.print("Head    adjacency nodes\n");
		System.out.print("------------------------------\n");
		for (index = 1; index <= total_vertex; index++) {
			System.out.print("V" + adjlist[index].vertex + " ");
			ptr = adjlist[index].link;
			while ( ptr != null ) {
				System.out.print("--> V" + ptr.vertex + " ");
				ptr = ptr.link;
			}
			System.out.print("\n");
		}
	}

	// 圖形之縱向優先搜尋
	public void dfs(int v)
	{
		Node ptr = new Node();
		int w=0;

		System.out.print("V" + adjlist[v].vertex + " ");
		visited[v] = true;          // 設定v頂點為已拜訪過
		ptr = adjlist[v].link;      /* 拜訪相鄰頂點*/

		do {
			/* 若頂點尚未走訪，則以此頂點為新啟始點繼續做縱向優先搜尋法走訪，
			否則找與其相鄰的頂點，直到所有相連接的節點都已走訪*/
			w = ptr.vertex;
			if ( visited[w] != true)
				dfs(w);
			else
				ptr = ptr.link;
		} while ( ptr != null);
	}

	public Node searchlast( Node linklist )
	{
		Node ptr = new Node();

		ptr = linklist;
		while ( ptr.link != null ) 
			ptr = ptr.link;
		return ptr;
	}
	
	public static void main(String args[])  // 主函數		 
	{
		DFSTest obj = new DFSTest();
 
		obj.build_adjlist(); // 以相鄰串列表示圖形
		obj.show_adjlist();  // 顯示串列之資料
		System.out.print("\n------Depth First Search------\n");
		obj.dfs(1);          // 圖形之縱向優先搜尋，以頂點1為起始頂點
	}
}
