package kruskal;

/**
 *
 * @author Bright
 * Version 2
 * Update date: March 23, 2017
 */

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.io.*;

class Edge 
{
	int vertex1;
	int vertex2;
	int weight;
	int edge_deleted;
}

class Graph
{
	int[] vertex = new int[100];
	int edges;
}

class Kruskal
{
	int MAX_V = 100; /*最大節點數*/
	int TRUE = 1;
	int FALSE = 0;
 
	Edge[] E = new Edge[MAX_V];
	Graph T = new Graph();
	int total_vertex = 0;
	int total_edge = 0;
	int[][] adjmatrix = new int[MAX_V][MAX_V];  // store matrix weight
 
	public void build_adjmatrix()
	{
		int vi=0, vj=0;
		String str;
        Scanner inputStream = null;
       
		try {
			inputStream = new Scanner(new FileInputStream("kruskal.dat"));
		} catch(FileNotFoundException e) {
			System.err.println("File kruskal.dat not found!");
			System.exit(1);
		}

		// 輸入節點總數
 		total_vertex = inputStream.nextInt();
	  
		for (vi = 1; vi <= total_vertex; vi++)
		{
			for ( vj = 1; vj <= total_vertex; vj++ ) {
 				adjmatrix[vi][vj] = inputStream.nextInt();
	  		}
		}
 		inputStream.close(); 
	}

	public void adjust()
	{
		Edge e;
		int i = 0, j = 0, weight = 0;

		for (i = 1; i <= total_vertex; i++)
			for ( j = i+1; j <= total_vertex; j++ ) {
				weight = adjmatrix[i][j];
				if ( weight != 0 ) {
					e = new Edge();
					e.vertex1 = i;
					e.vertex2 = j;
					e.weight = weight;
					e.edge_deleted = FALSE;
					addEdge(e);
				}
			}
	}

	public void addEdge(Edge e)
	{
		E[++total_edge] = e;
	}

	public void showEdge()
	{
		int  i = 1;

		System.out.print("Total Vertex = " + total_vertex + "  ");
		System.out.println("Total_edge = " + total_edge);
		while ( i <= total_edge ) {
			System.out.print("V" + E[i].vertex1 + "  <----->  V" + E[i].vertex2);
			System.out.println("   weight= " + E[i++].weight);
		}
	}

	public Edge mincostEdge()
	{
		int i = 0, min = 0, minweight = 10000000;

		for ( i = 1; i <= total_edge; i++ ) {
			if ((E[i].edge_deleted == FALSE) && (E[i].weight < minweight)) {
				minweight = E[i].weight;
				min = i;
			}
		}

		E[min].edge_deleted = TRUE;	  
		return E[min];
	}

	public void kruskal()
	{
		Edge e = new Edge();
		int i, loop=1;

		// init T
		for ( i = 1; i <= total_vertex; i++ )
			T.vertex[i] = 0;
		T.edges = 0;

		System.out.println("\nMinimum cost spanning tree using Kruskal");
		System.out.println("-------------------------------------------");

		while ( T.edges != (total_vertex - 1) ) {
			e = mincostEdge();

			if ( cyclicT(e) != 1) {
				System.out.print((loop++) + "th min edge : ");
				System.out.print("V" + e.vertex1 + "  <----->  V" + e.vertex2);
				System.out.println("  weight= " + e.weight);
			}
		}
	}

	public int cyclicT(Edge e)
	{
		int v1 = e.vertex1;
		int v2 = e.vertex2;

		T.vertex[v1]++;
		T.vertex[v2]++;
		T.edges++;
		if ( T.vertex[v1] >= 2 && T.vertex[v2] >= 2 ) {
			T.vertex[v1]--;
			T.vertex[v2]--;
			T.edges--;
			return TRUE;
		}
		else
			return FALSE;
	}

	public static void main (String args[]) //主函數		
	{ 
		Kruskal obj = new Kruskal();

		obj.build_adjmatrix();
		obj.adjust();
		obj.showEdge();
		obj.kruskal();
	}
}
