package topologysort;

/**
 *
 * @author Bright
 * Version 2
 * Update date: March 23, 2017
 */

import java.util.*;
import java.io.*;

/* 定義資料結構 */
class Node  
{
	int vertex;
	Node link;
}

class TopologySort
{
	final int MAX_V = 100;
	int N = 0, place = 0;
	Scanner inputStream = null;
	boolean[] visited = new boolean[MAX_V+1]; /* 記錄頂點是否已拜訪 */
	
	// 宣告相鄰串列
	int[] Top_order = new int[MAX_V+1];	Node[] adjlist = new Node[MAX_V+1]; 

 	public void build_adjlist()
	{
		Node node, lastnode;
		int vi = 0, vj = 0, weight = 0, t1 = -1, t2 = -1;
		boolean done = false;
		try {
			inputStream = new Scanner(new FileInputStream("top_sort.dat"));
		} catch(FileNotFoundException e) {
			System.err.println("File top_sort.dat not found!");
			System.exit(1);
		}
		// 讀取節點總數
 		N = inputStream.nextInt();
  		
 	    /* 設定陣列及各串列起始值 */
		for (vi = 1; vi <= N; vi++) {		
			adjlist[vi] = new Node();
			adjlist[vi].vertex = vi;
			adjlist[vi].link = null;
		}
		
		/* 讀取節點資料 */
		while (done == false) {
			try {
				vi = inputStream.nextInt();
				vj = inputStream.nextInt();
			}
 			catch(NoSuchElementException e) {	
				done = true;
			}
			
			/* 避免讀入重覆資料 */
			if (vi != t1 || vj != t2) {
				node = new Node();
				node.vertex = vj;
				node.link = null;
				if(adjlist[vi].link == null)
					adjlist[vi].link = node;
				else {
					lastnode = searchlast(adjlist[vi]);
					lastnode.link = node;
				}
				t1 = vi;
				t2 = vj;
			}
		}
 		inputStream.close();
 	}

	public void show_adjlist()
	{
		int v = 0;
		Node ptr;

		System.out.printf("\nHead   adjacency nodes\n");
		System.out.println("------------------------------");
		for (v = 1; v <= N; v++) {
			System.out.print("V" + adjlist[v].vertex + " ");
			ptr = adjlist[v].link;
			while (ptr != null) {
				System.out.print("--> V" + ptr.vertex + " ");      
				ptr = ptr.link;
			}
			System.out.println("");
		}
	}

	public void topological()
	{
		int v = 0;

		for (v = 1; v <= N; v++)
			visited[v] = false;
		place = N;
		for (v = 1; v <= N; v++)
			if (visited[v] != true)
				top_sort(v);
	}

	public void top_sort(int k)
	{
		Node ptr;
		int w = 0;
		visited[k] = true; 
			
		/* 拜訪v相鄰頂點 */	        
		ptr = adjlist[k].link;  
		while (ptr != null) {
 			w = ptr.vertex;        
			if (visited[w] != true)
				top_sort(w);
			ptr = ptr.link;
		}
		Top_order[--place] = k;
	}

	public Node searchlast(Node linklist)
	{
		Node ptr;

		ptr = linklist;
		while (ptr.link != null)
			ptr = ptr.link;
		return ptr;
	}

	public void show_topological()
	{
		int i = 0;
    
		System.out.println("\n------Topological order sort------");
		for (i = 0; i < N; i++)
			System.out.print("V" + Top_order[i] + " ");
		System.out.println("");
	}

	public static void main(String args[]) 		     
	{
		TopologySort obj = new TopologySort();
 
		obj.build_adjlist();   
		obj.show_adjlist();     
		obj.topological();       
		obj.show_topological();
 	}
}
