package hashingtable;

/**
 *
 * @author Bright
 * Version 2
 * Update date: March 22, 2017
 */

import java.util.Scanner;
class Student
{
	public int id;
	public String name;
	public Student link;
}

public class HashingTable 
{
	int MAX_NUM = 100; // 最大資料筆數  
	int PRIME = 97;    // 最大MAX_NUM之質數
	Student NOTEXISTED = null;
	Student[] Hashtab = new Student[MAX_NUM]; // 建立雜湊表串列
	static Scanner keyboard = new Scanner(System.in);
 
	HashingTable() // 建構函數
	{
		int i=0; 
		//起始雜湊串列，將各串列指向NULL
		for ( i = 0; i< MAX_NUM ; i++)
			Hashtab[i] = null ;      	    		
	}

	// 雜湊函數: 以除法運算傳求出記錄應儲存的位址
	public int hashfun(int key)
	{
		return ( key % PRIME ) ;
	}

	public void insert()
	{
		Student newnode;
		int index = 0 ;

		// 輸入記錄
		newnode = new Student() ;
		newnode.link = null ;
		System.out.print("\nEnter ID : ");
 		newnode.id = keyboard.nextInt();
  
		System.out.print("Enter name : ");
 		newnode.name = keyboard.next();
       
		// 利用雜湊函數求得記錄位址
		index = hashfun(newnode.id) ;
		// 判斷該串列是否為空，若為空則建立此鏈結串列
		if ( Hashtab[index] == null ) {
			Hashtab[index] = newnode ;
			System.out.print("加入成功!\n");
		}
		else {	
			// 搜尋節點是否已存在串列中
			// 如未存在則將此節點加入串列前端
			if ((search(Hashtab[index],newnode)) == NOTEXISTED) {
				newnode.link = Hashtab[index] ;
				Hashtab[index] = newnode ;		   
				System.out.print("加入成功!");
			}
			else
				System.out.print("此筆已存在...\n");
		}
		System.out.print("\n");
	}      

	// 刪除節點函數
	public void del()
	{
		char ch;
		String more = "";
		Student node, node_parent;
		int index = 0 ;

		node = new Student() ;
		System.out.print("\nEnter ID : ");
 		node.id = keyboard.nextInt();
 
		// 利用雜湊函數轉換記錄位址
		index  =  hashfun(node.id) ;
		// 判斷該串列是否為空，若為空則建立此鏈結串列
		if  (Hashtab[index]==null)  {
			System.out.print("Record not existed ...\n\n");		   
			return;
		}	  
		node  = search(Hashtab[index],node) ;

		if ( node == NOTEXISTED )
			System.out.print("Record not existed ...\n\n") ;
		else {
			// 搜尋節點是否已存在串列中，
			// 如未存在則將此節點加入串列前端
			System.out.printf("ID : %d, ", node.id);
			System.out.printf("Name : %s\n", node.name);
			
			//尋問使用者是否真的要刪除此資料
		    System.out.printf("確定要刪除嗎? (y/n): ");	
		    more = keyboard.next();
 		    ch = more.charAt(0);	
			if (ch == 'y') {
			  if (node == Hashtab[index])
				 Hashtab[index] = null ;
		  	  else {
				 node_parent = Hashtab[index] ;
				 while ( node_parent.link.id != node.id )
					 node_parent = node_parent.link ;
				 node_parent.link = node.link ;
			  }  
			  System.out.printf("It has been deleted\n\n") ;	
			}
		}
    }
    
	// 搜尋節點函數
	// 如找到節點則傳回指向該節點之指標
	// 否則傳回null
	public Student search(Student linklist, Student Node)
	{     
		Student ptr = new Student();
		
		ptr = linklist ;     
		while (ptr.id != Node.id && ptr.link != null)
			ptr = ptr.link ;

		if (ptr == null)
			return NOTEXISTED ;
		else
			return ptr ;
	}

	// 查詢節點函數
	public void query()
	{
		Student query_node = new Student() ;
		int index = 0;

		query_node = new Student() ;
		System.out.print("\nEnter ID : ");
 		query_node.id = keyboard.nextInt();
 
		index = hashfun(query_node.id) ;
		// 搜尋節點	  
		if (Hashtab[index]==null) {
			System.out.printf("Record not existed...\n\n");		   
			return;
		}

		query_node = search(Hashtab[index],query_node);	  

		if ( query_node == NOTEXISTED )
			System.out.printf("Record not existed...\n\n");
		else {
			System.out.printf("ID : %d, ", query_node.id);
			System.out.printf("Name : %s\n", query_node.name) ;
		}
		System.out.print("\n");
	}

	// 顯示節點函數
	// 從雜湊串列一一尋找是否有節點存在
	public void show()
	{
		int i, flag = 0;
		Student ptr = new Student() ;

		System.out.printf("\n%-15s %-15s\n", "ID", "NAME") ;
		System.out.printf("------------------------\n") ;
		for ( i = 0 ; i < MAX_NUM ;i++ ) {
			// 串列不為空，則將整串列顯示出
			if ( Hashtab[i] != null ) {
				flag = 1;
				ptr = Hashtab[i] ;
				while (ptr != null) {
					System.out.printf("%-15d", ptr.id) ;
					System.out.printf("%-15s\n", ptr.name) ;
					ptr = ptr.link ;
				}
			}
		}
 		if(flag == 0){		
				System.out.printf("No record in hashing table\n");
		}
		System.out.print("\n");
	}

	public static void main (String args[])
	{ 
		int option;  
	   
		HashingTable obj = new HashingTable();
		do {
			System.out.println();			 
			System.out.println("******* Hashing table *******");
			System.out.println("         <1> Insert          ");
			System.out.println("         <2> Delete          ");
			System.out.println("         <3> Show            "); 
			System.out.println("         <4> Sch             ");
			System.out.println("         <5xit               ");
			System.out.println("*****************************");
			System.out.print("\n          Choice : ");			 
			option = keyboard.nextInt();
	 
			switch(option) {			   
				case 1 :
					obj.insert();  //新增函數
					break;
				case 2 :
					obj.del();     //刪除函數
					break;
				case 3 :
					obj.show();    //輸出函數
					break;
				case 4 :
					obj.query();   //查詢函數
					break;
				case 5 : System.exit(0);	
		  }
		} while (true);
	}
}
